/**
 *	jDiagram v0.1b - organization diagram drawing plugin for jQuery
 *
 *	by Aleksandar Ruzicic <krckoorascic@gmail.com>
 */


$.fn.jDiagram = function(o)
{
	var parent = $(this);
	var myWidth = parseInt(parent.css('width'));
	var border = '1px';
	var rows = 1;
	var data = {};

	opts =
	{
		width: 140,
		height: 40,
		vspacing: 10,
		hspacing: 10
	};

	if (o) $.extend(opts, o);

	function parseChildren(dl)
	{
		var children = [];
		var child = {};

		dl.children().each(function()
		{
			child =
			{
				text: [$('h3', $(this)).html(), $('em', $(this)).html()],
				children: parseChildren($('dl', $(this)).eq(0))
			};

			children.push(child);
		});

		return children;
	}

	data =
	{
		text: [$('dl>li>h3', $(this)).html(), $('dl>li>em', $(this)).html()],
		children: parseChildren($('dl li dl', $(this)).eq(0))
	};

	parent.empty();

	function drawNode(nodeData, x, y, top, row)
	{
		if (rows < row) rows = row;

		var node = $('<div class="node"><h3>' + nodeData.text[0] + '</h3><span>' + nodeData.text[1] + '</span></div>');
		var w = opts.width;
		var h = opts.height;
		var n = nodeData.children.length;

		node.css({left: x - w / 2, top: y, width: w, height: h});
		parent.append(node);

		if (top)
		{
			parent.append($('<div class="line"></div>').css({left:x, top:y-opts.vspacing/2-1, height:opts.vspacing/2, 'border-left':border}));
		}

		if (n > 0)
		{
			parent.append($('<div class="line"></div>').css({left:x, top:y+h+2,height:opts.vspacing/(n==1?1:2), 'border-left':border}));

			if (n == 1)
			{
				drawNode(nodeData.children[0], x, y + h + 4 + opts.vspacing, false, row + 1);
			}
			else
			{
				var first = x - (n % 2 == 0 ? (w / 2 + opts.hspacing) : 0) - (w + opts.hspacing) * (Math.floor((n - 1) / 2)) + ((n % 2 == 0) * (opts.hspacing / 2));

				parent.append($('<div class="line"/>').css({left:first, top:y+h+3+opts.vspacing/2, width:(x-first)*2-1, 'border-top':border}));

				for (var i = 0; i < nodeData.children.length; i++)
				{
					drawNode(nodeData.children[i], first + i * (w + opts.hspacing), y + h + opts.vspacing * 1.5, true, row + 1);
				}
			}
		}
	}

	drawNode(data, myWidth / 2, opts.vspacing, false, 2);

	parent.css({height: rows * (opts.height + opts.vspacing) - opts.vspacing * 2});

	parent.show(); // force gecko to update height
}